declare-user-mode surround
declare-user-mode surround-add
define-command -override surround-add-pair -params 2 %{
    evaluate-commands -draft -save-regs '"' %{
        set-register '"' %arg{1}
        execute-keys -draft P
        set-register '"' %arg{2}
        execute-keys -draft p
    }
}

# command surrounds with any arbitrary character
define-command -override surround-add -params 1 %{
    evaluate-commands -draft -save-regs '"' %{
        set-register '"' %arg{1}
        execute-keys -draft P
        execute-keys -draft p
    }
}

define-command -hidden surround-delete-key -params 1 %{
    execute-keys -draft "<a-a>%arg{1}i<del><esc>a<backspace><esc>"
}

define-command surround-delete %{
    on-key %{
        surround-delete-key %val{key}
    }
}

define-command -hidden surround-replace-sub -params 1 %{
    on-key %{
        evaluate-commands -no-hooks -draft %{
            execute-keys "<a-a>%arg{1}"
            enter-user-mode surround-add
            execute-keys %val{key}
        }

        surround-delete-key %arg{1}
    }
}

define-command surround-replace %{
    on-key %{
        surround-replace-sub %val{key}
    }
}

map global surround-add ( ':surround-add-pair ( )<ret>'           -docstring 'surround with parenthesis'
map global surround-add ) ':surround-add-pair ( )<ret>'           -docstring 'surround with parenthesis'
map global surround-add [ ':surround-add-pair [ ]<ret>'           -docstring 'surround with brackets'
map global surround-add ] ':surround-add-pair [ ]<ret>'           -docstring 'surround with brackets'
map global surround-add { ':surround-add-pair { }<ret>'            -docstring 'surround with braces'
map global surround-add } ':surround-add-pair { }<ret>'           -docstring 'surround with braces'
map global surround-add < ':surround-add-pair "<" ">"<ret>'            -docstring 'surround with angles'
map global surround-add > ':surround-add-pair < ><ret>'           -docstring 'surround with angles'
map global surround-add "'" ":surround-add-pair ""'"" ""'""<ret>" -docstring 'surround with quotes'
map global surround-add '"' ":surround-add-pair '""' '""'<ret>"   -docstring 'surround with double quotes'
map global surround-add *   ':surround-add-pair * *<ret>'         -docstring 'surround with asteriks'
map global surround-add _   ':surround-add-pair _ _<ret>'         -docstring 'surround with undescores'

map -docstring 'surround' global normal k ': enter-user-mode surround<ret>'
map -docstring 'add surrounding' global surround s ': enter-user-mode surround-add<ret>'
map -docstring 'delete surrounding' global surround d ':surround-delete<ret>'
map -docstring 'replace surrounding' global surround r ':surround-replace<ret>'
